#include "CCamera.h"

CCamera::CCamera(int Width, int Height, int MaxWidth, int MaxHeight)
{
    CameraRect.w = Width;
    CameraRect.h = Height;
    CameraRect.x = 0;
    CameraRect.y = 0;
    PMaxHeight = MaxHeight;
    PMaxWidth = MaxWidth;
    PCenterPosX = Width >> 1;
    PCenterPosY = Height >> 1;
}

int CCamera::GetCenterPosX(int X)
{
    if (X + PCenterPosX >= PMaxWidth)
        return X % CameraRect.w;
    else
        if (X <= (PCenterPosX))
            return X;
        else
            return PCenterPosX;
}

int CCamera::GetCenterPosY(int Y)
{
    if (Y + PCenterPosY >= PMaxHeight)
        return Y % CameraRect.h;
    else
        if (Y <= (PCenterPosY))
            return Y;
        else
            return PCenterPosY;
}


void CCamera::SetPos(int X, int Y)
{


    if (X + PCenterPosX >= PMaxWidth)
        CameraRect.x = PMaxWidth - PCenterPosX;
    else
        if (X <= (PCenterPosX))
            CameraRect.x = PCenterPosX;
        else
            CameraRect.x = X;

    if (Y + PCenterPosY >= PMaxHeight)
        CameraRect.y = PMaxHeight - PCenterPosY;
    else
        if (Y <= (PCenterPosY))
            CameraRect.y = PCenterPosY;
        else
            CameraRect.y = Y;


    CameraRect.x = CameraRect.x - PCenterPosX;
    CameraRect.y = CameraRect.y - PCenterPosY;
}
