#include "CSlideDoor.h"

CSlideDoor::~CSlideDoor() {

}

void CSlideDoor::Move() {
    if(PEnabled)
    {
        if(PActive)
        {
            PPreviousXPos = PXPos;
            PPreviousXPos = PYPos;
            PXPos += PXi;
            PYPos += PYi;
            PVisibleX = (int)fix2float<16>(PXPos);
            PVisibleY = (int)fix2float<16>(PYPos);
            if( PVisibleX >= PLocation.w)
            {
                PVisibleX = PLocation.w;
                PXi = -PXi;
            }
            if( PVisibleY >= PLocation.h)
            {
                PVisibleY= PLocation.h;
                PYi = -PYi;
            }
            if(PVisibleX < 0)
            {
                PXi = -PXi;
                PVisibleX = 0;
                PActive = false;
                if (PRandomTime)
                    PActivatedTime = SDL_GetTicks() + rand()%PTime;
                else
                    PActivatedTime = SDL_GetTicks() + PTime;
            }
            if(PVisibleY < 0)
            {
                PYi = -PYi;
                PVisibleY = 0;
                PActive = false;
                if (PRandomTime)
                    PActivatedTime = SDL_GetTicks() + rand()%PTime;
                else
                    PActivatedTime = SDL_GetTicks() + PTime;
            }


        }
        else
            if(PActivatedTime < SDL_GetTicks())
                PActive = true;

    }
}

void CSlideDoor::Draw(SDL_Surface *Dst)
{
    rectangleRGBA(Dst,PLocation.x,PLocation.y,PLocation.x+PLocation.w-1,PLocation.y + PLocation.h-1,0,0,255,255);
    switch (PId)
    {
        case DSLIDEDOORUPID:
            if(PVisibleY !=0)
                rectangleRGBA(Dst,PLocation.x,PLocation.y+PLocation.h-1,PLocation.x + PLocation.w-1,PLocation.y+PLocation.h-1 - PVisibleY,255,0,255,255);
            break;
        case DSLIDEDOORDOWNID:
            if(PVisibleY !=0)
                rectangleRGBA(Dst,PLocation.x,PLocation.y,PLocation.x + PLocation.w-1,PLocation.y+ PVisibleY,255,0,255,255);
            break;
        case DSLIDEDOORLEFTID:
            if(PVisibleX !=0)
                rectangleRGBA(Dst,PLocation.x+PLocation.w-1,PLocation.y,PLocation.x + PLocation.w-1-PVisibleX,PLocation.y+PLocation.h-1,255,0,255,255);
            break;
        case DSLIDEDOORRIGHTID:
            if(PVisibleX !=0)
                rectangleRGBA(Dst,PLocation.x,PLocation.y,PLocation.x +PVisibleX,PLocation.y+PLocation.h-1,255,0,255,255);
            break;
        default:
            break;
    }

}

SDL_Rect CSlideDoor::GetLocation()
{

    /*SDL_Rect Rect;


    switch (PId)
    {
        case DSLIDEDOORUPID:


            Rect.x = PLocation.x;
            Rect.y = PLocation.y+PLocation.h-PVisibleY;


            Rect.w = PLocation.w;
            Rect.h = PVisibleY;
            break;
        case DSLIDEDOORDOWNID:


            Rect.x = PLocation.x;
            Rect.y = PLocation.y;


            Rect.w = PLocation.w;
            Rect.h = PVisibleY;
            break;
        case DSLIDEDOORLEFTID:


            Rect.x = PLocation.x+PLocation.w-PVisibleX;
            Rect.y = PLocation.y;


            Rect.w = PVisibleX;
            Rect.h = PLocation.h;
            break;
        case DSLIDEDOORRIGHTID:

            Rect.x = PLocation.x;
            Rect.y = PLocation.y;


            Rect.w = PVisibleX;
            Rect.h = PLocation.h;
            break;
        default:
            Rect.x = 0;
            Rect.y = 0;
            Rect.w = 0;
            Rect.h = 0;
            break;

    }*/

    return PLocation;
    //return PLocation;
}

SDL_Rect CSlideDoor::GetRealLocation()
{

    SDL_Rect Rect;


    switch (PId)
    {
        case DSLIDEDOORUPID:


            Rect.x = PLocation.x;
            Rect.y = PLocation.y+PLocation.h-1-PVisibleY;


            Rect.w = PLocation.w;
            Rect.h = PVisibleY;
            break;
        case DSLIDEDOORDOWNID:


            Rect.x = PLocation.x;
            Rect.y = PLocation.y;


            Rect.w = PLocation.w;
            Rect.h = PVisibleY;
            break;
        case DSLIDEDOORLEFTID:


            Rect.x = PLocation.x+PLocation.w-PVisibleX-1;
            Rect.y = PLocation.y;


            Rect.w = PVisibleX;
            Rect.h = PLocation.h;
            break;
        case DSLIDEDOORRIGHTID:

            Rect.x = PLocation.x;
            Rect.y = PLocation.y;


            Rect.w = PVisibleX;
            Rect.h = PLocation.h;
            break;
        default:
            Rect.x = 0;
            Rect.y = 0;
            Rect.w = 0;
            Rect.h = 0;
            break;

    }

    return Rect;
    //return PLocation;
}

