#ifndef CSLIDEDOOR_H
#define CSLIDEDOOR_H

#include "CPart.h"
#include "Race.h"


class CSlideDoor : public CPart
{
    protected:
        int PXi;
        int PYi;
        int PXPos;
        int PYPos;
        int PVisibleX;
        int PVisibleY;
        int PType;
        int RandomSeed;
        int PTime;
        bool PActive;
        bool PEnabled;
        bool PRandomTime;
        bool PAiPassedIt;
        int PPreviousXPos;
        int PPreviousYPos;
        Uint32 PActivatedTime;
    public:
         CSlideDoor(int X,int Y,int W,int H,float Xi,float Yi,bool RandomTime,int Time,SDL_Surface *Surface) :  CPart(X,Y,W,H,Surface)
        {
            PAiPassedIt=false;
            PTime = Time;
            PGroup = DGROUPSLIDEDOOR;
            PZ = DSLIDEDOORZ;
            PXi = float2fix<16>(Xi);
            PYi = float2fix<16>(Yi);
            PXPos = 0;
            PYPos = 0;
            PPreviousXPos = 0;
            PPreviousYPos = 0;
            PRandomTime = RandomTime;
            PActive = false;
            PVisibleX = 0;
            PVisibleY = 0;
            if (RandomTime)
                PActivatedTime = SDL_GetTicks() + rand()%Time;
            else
                PActivatedTime = SDL_GetTicks() + Time ;
            PType = -1;
            PEnabled = false;
        }

        ~CSlideDoor();

        void Move();
        void Draw(SDL_Surface *Dst);
        inline bool GetAiPassedIt(){return PAiPassedIt;}
        inline void SetAiPassedIt(bool AiPassedIt) {PAiPassedIt = AiPassedIt;}
        SDL_Rect GetRealLocation();
        SDL_Rect GetLocation();
        int GetDiffY() {return (int)fix2float<16>(PYPos - PPreviousYPos);}
        int GetDiffX() {return (int)fix2float<16>(PXPos - PPreviousXPos);}
};

#endif
